#!/usr/bin/perl -w

# read symbols of a file
sub readSymbols
{
	my($file, $line, %symbols) = shift;
	local(*IN);
	
	open(IN, "<$file") ||
		die "Could not open $file: $!";
	
	while (defined($line = <IN>)) {
		next unless $line =~/([0-9a-f]{8})\sT\s(.+)/i;
		$symbols{$1} = $2;
	}
	
	close IN;
	
	%symbols;
}

#read symbols of file "out" and parse stdin
sub main
{
	my($line, $level, %symbols);
	
	%symbols = &readSymbols("out.sym");
	
	$level = 0;
	
	while (defined($line = <>)) {
		if ($line =~/^(e|l)([a-f0-9]{8})/) {
			my($action, $addr) = ($1, $2);
			if ($action eq "e") {
				print "  " x ($level);
				print $addr,
					exists($symbols{$addr}) ? ": $symbols{$addr}\n" : "\n";
				++$level;
			} else {
				--$level;
			}
		} elsif ($line =~s/^m//) {
			$line =~ tr/\x00-\x08\x0a-\x1F\x7f-\xff//ds;
			print "  " x ($level), $line, "\n";
		}
		if ($line =~/BEGIN$/) {
			$level = 0;
		}
	}
}

&main();

