/* Simple Bottom Half Task Scheduler
   Copyright (c) 2010 Networked Systems Group, University of Kaiserslautern

This file is part of the Imote2 Bootloader

The Bootloader is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

The Bootloader is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef TASK_H
#define TASK_H

#include <inttypes.h>

/** \file task.h
 * \brief definition of bottom half routines
 */

/** \brief task structure */
struct Task {
	/** \brief pointer to bottom half routine */
	void (*task)();
	/** \brief \c TRUE iff routine can be interrupted by any interrupt */
	bool interruptible;
	/** \brief link to the next bottom half or \c NULL iff there is none */
	struct Task * next;
};

void taskRun();

void taskAdd(void (*task)(), bool interruptible);

bool taskPending();

#endif

